## net.sf.saxon.sort
Class CalendarValueComparer

    java.lang.Object
      net.sf.saxon.sort.CalendarValueComparer

All Implemented Interfaces:
  java.io.Serializable, AtomicComparer

    public class CalendarValueComparer

extends java.lang.Object
implements AtomicComparer

A comparer specifically for comparing two date, time, or dateTime values

See Also:
  Serialized Form

Constructor Summary
`CalendarValueComparer(XPathContext context)`

Method Summary
`int` `compareAtomicValues(AtomicValue a, AtomicValue b)` Compare two AtomicValue objects according to the rules for their data type.
`boolean` `comparesEqual(AtomicValue a, AtomicValue b)` Compare two AtomicValue objects for equality according to the rules for their data type.
`ComparisonKey` `getComparisonKey(AtomicValue a)` Get a comparison key for an object.
`AtomicComparer` `provideContext(XPathContext context)` Supply the dynamic context in case this is needed for the comparison

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### CalendarValueComparer

    public CalendarValueComparer(XPathContext context)

Method Detail

### provideContext

    public AtomicComparer provideContext(XPathContext context)

  Supply the dynamic context in case this is needed for the comparison

  Specified by:
    `provideContext` in interface `AtomicComparer`
  Parameters:
    `context` - the dynamic evaluation context
  Returns:
    either the original AtomicComparer, or a new AtomicComparer in which the context is known. The original AtomicComparer is not modified
  Throws:
    `NoDynamicContextException` - if the context is an "early evaluation" (compile-time) context

### compareAtomicValues

    public int compareAtomicValues(AtomicValue a,
                                   AtomicValue b)
                            throws NoDynamicContextException

  Compare two AtomicValue objects according to the rules for their data type. UntypedAtomic values are compared as if they were strings; if different semantics are wanted, the conversion must be done by the caller.

  Specified by:
    `compareAtomicValues` in interface `AtomicComparer`
  Parameters:
    `a` - the first object to be compared. It is intended that this should be an instance of AtomicValue, though this restriction is not enforced. If it is a StringValue, the collator is used to compare the values, otherwise the value must implement the java.util.Comparable interface.
    `b` - the second object to be compared. This must be comparable with the first object: for example, if one is a string, they must both be strings.
  Returns:
    <0 if a<b, 0 if a=b, >0 if a>b
  Throws:
    `java.lang.ClassCastException` - if the objects are not comparable
    `NoDynamicContextException` - if this comparer required access to dynamic context information, notably the implicit timezone, and this information is not available. In general this happens if a context-dependent comparison is attempted at compile-time, and it signals the compiler to generate code that tries again at run-time.

### comparesEqual

    public boolean comparesEqual(AtomicValue a,
                                 AtomicValue b)
                          throws NoDynamicContextException

  Compare two AtomicValue objects for equality according to the rules for their data type. UntypedAtomic values are compared by converting to the type of the other operand.

  Specified by:
    `comparesEqual` in interface `AtomicComparer`
  Parameters:
    `a` - the first object to be compared. It is intended that this should be an instance of AtomicValue, though this restriction is not enforced. If it is a StringValue, the collator is used to compare the values, otherwise the value must implement the equals() method.
    `b` - the second object to be compared. This must be comparable with the first object: for example, if one is a string, they must both be strings.
  Returns:
    true if the values are equal, false if not
  Throws:
    `java.lang.ClassCastException` - if the objects are not comparable
    `NoDynamicContextException`

### getComparisonKey

    public ComparisonKey getComparisonKey(AtomicValue a)
                                   throws NoDynamicContextException

  Get a comparison key for an object. This must satisfy the rule that if two objects are equal, then their comparison keys are equal, and vice versa. There is no requirement that the comparison keys should reflect the ordering of the underlying objects.

  Specified by:
    `getComparisonKey` in interface `AtomicComparer`
  Throws:
    `NoDynamicContextException`

Copyright (c) Saxonica Limited. All rights reserved.